<?php

namespace backend\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use common\models\City;

/**
 * CitySearch represents the model behind the search form about `common\models\City`.
 */
class CitySearch extends City
{
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['id_city', 'cso_code', 'rig_id', 'population', 'homes'], 'integer'],
            [['zip', 'name', 'city_code'], 'safe'],
            [['latitude', 'longitude', 'range'], 'number'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = City::find();

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        $query->andFilterWhere([
            'id_city' => $this->id_city,
            'latitude' => $this->latitude,
            'longitude' => $this->longitude,
            'cso_code' => $this->cso_code,
            'rig_id' => $this->rig_id,
            'range' => $this->range,
            'population' => $this->population,
            'homes' => $this->homes,
        ]);

        $query->andFilterWhere(['like', 'zip', $this->zip])
            ->andFilterWhere(['like', 'name', $this->name])
            ->andFilterWhere(['like', 'city_code', $this->city_code]);

        return $dataProvider;
    }
}
